gtkmm: Gtk::Native Class Reference

gtkmm 4.12.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::Native Class Reference

Interface for widgets having surfaces. More...

`#include <gtkmm/native.h>`

Inheritance diagram for Gtk::Native:
[legend]

## Public Member Functions
| Native (Native && src) noexcept
Native & | operator= (Native && src) noexcept
| ~Native () noexcept override
GtkNative * | gobj ()
| Provides access to the underlying C GObject.
const GtkNative * | gobj () const
| Provides access to the underlying C GObject.
void | realize ()
| Realizes a `Gtk::Native`.
void | unrealize ()
| Unrealizes a `Gtk::Native`.
Glib::RefPtr< Gdk::Surface > | get_surface ()
| Returns the surface of this `Gtk::Native`.
Glib::RefPtr< const Gdk::Surface > | get_surface () const
| Returns the surface of this `Gtk::Native`.
void | get_surface_transform (double & x, double & y)
| Retrieves the surface transform of self.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Native * | get_for_surface (const Glib::RefPtr< const Gdk::Surface > & surface)
| Finds the `Gtk::Native` associated with the surface.

## Protected Member Functions
| Native ()
| You should derive from this class to use it.
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::Native > | wrap (GtkNative * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Interface for widgets having surfaces.

Gtk::Native is the interface implemented by all widgets that can provide a Gdk::Surface for widgets to render on.

The obvious example of a Gtk::Native is Gtk::Window.

See also
  Gtk::Root, Gtk::Window

Since gtkmm 3.96:

## Constructor & Destructor Documentation

## ◆ Native() [1/2]

Gtk::Native::Native | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ Native() [2/2]

Gtk::Native::Native | ( | Native && | src | ) |
| noexcept

## ◆ ~Native()

Gtk::Native::~Native | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gtk::Native::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ get_for_surface()

static Native * Gtk::Native::get_for_surface | ( | const Glib::RefPtr< const Gdk::Surface > & | surface | ) |
| static

Finds the `Gtk::Native` associated with the surface.

Parameters

  surface | A `Gdk::Surface`.

Returns
  The `Gtk::Native` that is associated with surface.

## ◆ get_surface() [1/2]

Glib::RefPtr< Gdk::Surface > Gtk::Native::get_surface | ( |  | ) |

Returns the surface of this `Gtk::Native`.

Returns
  The surface of self.

## ◆ get_surface() [2/2]

Glib::RefPtr< const Gdk::Surface > Gtk::Native::get_surface | ( |  | ) | const

Returns the surface of this `Gtk::Native`.

Returns
  The surface of self.

## ◆ get_surface_transform()

void Gtk::Native::get_surface_transform | ( | double & | x,
|  | double & | y
| ) |  |

Retrieves the surface transform of self.

This is the translation from self's surface coordinates into self's widget coordinates.

Parameters

  x | Return location for the x coordinate.
  y | Return location for the y coordinate.

## ◆ get_type()

static GType Gtk::Native::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkNative * Gtk::Native::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkNative * Gtk::Native::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

Native & Gtk::Native::operator= | ( | Native && | src | ) |
| noexcept

## ◆ realize()

void Gtk::Native::realize | ( |  | ) |

Realizes a `Gtk::Native`.

This should only be used by subclasses.

## ◆ unrealize()

void Gtk::Native::unrealize | ( |  | ) |

Unrealizes a `Gtk::Native`.

This should only be used by subclasses.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::Native > wrap | ( | GtkNative * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.